/*****************************************************************************/
/*        GWW[                                                                                                                        */
/*****************************************************************************/
importPackage(Packages.jp.co.intra_mart.system.common.parts.search_bar);
var ImSearchEngineList = null;
var logger4js = Logger.getLogger("jp.co.intra_mart.system.common.parts.search_bar");

function init() {
	// ֐錾
	Procedure.define("ImSearchEngine", new ImSearchEngine());
	// GWǂݍ
	_getEngineList();
}

function ImSearchEngine() {
	this.getEngineList = _getEngineList;
	this.getYSPSearchResult = _getYSPSearchResult;
	this.getYSPQueryString = _getYSPQueryString;
	this.getSponsoredSearchResult = _getSponsoredSearchResult;
}

function _getEngineList() {
	if( !isNull(ImSearchEngineList) ) {
		return ImSearchEngineList;
	}
	
	// EngineList
	ImSearchEngineList = new Array();
	
	// ̑XMLǂݍ
	var file = new VirtualFile("system/search/search_engine.xml");
	if( file.isFile() ) {
		var xml = new XML( file.read() );
		
		var engine = xml.Engine;
		var length = engine.length();
		for(var i = 0; i < length; i++) {
			obj = new Object();
			obj.id = engine[i].id.text().toXMLString();
			obj.src = engine[i].Image.text().toXMLString();
			obj.title = engine[i].ShortName.text().toXMLString();
			obj.inputEncoding = engine[i].InputEncoding.text().toXMLString();
			obj.url = engine[i].Url.@template.toXMLString();
			obj.type = engine[i].Url.@type.toXMLString();
			
			ImSearchEngineList.push( obj );
		}
	}
	return ImSearchEngineList;
}

function _getYSPQueryString(keyword) {
	// NGp[^
	var query = YSPSearchKeys.getQueryParameters();
	
	var request = Web.getRequest();
	var xfip = request.getHeader("x-fowarded-for");
	query += "&" + YSPSearchKeys.IP_KEY + "=" + URL.encode((isBlank(xfip) ? Web.getRemoteAddr() : xfip), "utf-8"); // encode for ipv6
	query += "&" + YSPSearchKeys.USERAGENT_KEY + "=" + URL.encode(request.getHeader("User-Agent"), "utf-8");
	
	// L[[hURLGR[fBO
	var encKey = URL.encode( keyword, "utf-8" );
	encKey = encKey.replace("@", "%40", "g");
	encKey = encKey.replace("*", "%2a", "g");
	
	query += "&" + YSPSearchKeys.QUERY_KEY + "=" + encKey;
	return query;
}

function _getYSPSearchResult(keyword, queryStr) {
	// YSP URL
	var url = YSPSearchKeys.YSP_URL;
	
	if( isBlank(queryStr) ) {
		// NG
		queryStr =  _getYSPQueryString(keyword);
	}
	try {
		// YSP ₢킹
		var result = readUrl(url + "?" + queryStr, "utf-8");
		return result;
	} catch (e) {
		var logger = Packages.jp.co.intra_mart.common.platform.log.Logger.getLogger("jp.co.intra_mart.system.common.parts.search_bar");
		logger.error(e.message,	e.rhinoException);
	}
}

function _getSponsoredSearchResult(keyword, nextArgs) {
	// SponsoredSearch URL
	var url = SSearchKeys.getURL();
	
	// NCAgIPAhX
	//O[oIPAhXŎ擾
	var clientIP = SSearchKeys.getClientIP();
	//擾łȂWeb.getRemoteAddr()Ŏ擾lݒ
	var remoteAddr = Web.getRemoteAddr();
	if(isNull(clientIP)){
		clientIP = remoteAddr;
	}
	// \tgEFA(WebuEU)
	var request = Web.getRequest();
	var userAgent = request.getHeader("User-Agent");
	// NCAgvLV[eBOO[v
	var xfip = request.getHeader("x-fowarded-for");
	
	// [U̐
	var affilData = "ip=" + clientIP + "&ua=" + userAgent;
	if( !isBlank(xfip) ) {
		affilData += "&xfip=" + xfip;
	}
	
	// NG
	var query = new Array();
	// Œp[^
	query[0] = SSearchKeys.getQueryParameters();
	// [U
	query[1] = SSearchKeys.AFFILIATE_DATA_KEY + "=" + URL.encode(affilData, "utf-8");
	// L[[h
	if( isBlank(nextArgs) ) {
		var encKey = URL.encode(keyword, "utf-8");
		encKey = encKey.replace("@", "%40", "g");
		encKey = encKey.replace("*", "%2a", "g");
		query[2] = SSearchKeys.QUERY_KEY + "=" + encKey;
	} else {
		query[2] = nextArgs;
	}
	
	try {
		url = url + "?" + query.join("&");
		if (logger4js.isDebugEnabled()) {
			logger4js.debug("Search Request URL: " + url);
		}
		var result = readUrl(url, "utf-8");
		return result;
	} catch (e) {
		var logger4j = Packages.jp.co.intra_mart.common.platform.log.Logger.getLogger("jp.co.intra_mart.system.common.parts.search_bar");
		logger4j.error(e.message, e.rhinoException);
	}
}
